#ifndef _PARMS_OPERATOR_IMPL_H_
#define _PARMS_OPERATOR_IMPL_H_

#include "parms_vec.h"
#include "parms_operator.h"
#include "parms_object_impl.h"

typedef int  (*Apply)(parms_Operator self, parms_Vec y, parms_Vec x);
typedef int  (*Lsol)(parms_Operator self, FLOAT *y, FLOAT *x);
typedef int  (*InvS)(parms_Operator self, FLOAT *y, FLOAT *x);
typedef int  (*Ascend)(parms_Operator self, FLOAT *y, FLOAT *x);
typedef int  (*Getssize)(parms_Operator self);
typedef void (*GetNnz)(parms_Operator self, int *nnz_mat, int
		       *nnz_pc); 


typedef struct parms_Operator_ops {
  Apply    apply;
  Lsol     lsol;
  InvS     invs;
  Ascend   ascend;
  Getssize getssize;
  GetNnz   getnnz;
} *parms_Operator_ops;

struct parms_Operator_ {
  PARMS_OBJHEADER(parms_Operator_ops)
  void *data;
};

#endif 
