#ifndef _PARMS_PC_IMPL_H_
#define _PARMS_PC_IMPL_H_

#include "parms_pc.h"
#include "parms_vec.h"
#include "parms_mat_impl.h"

typedef struct parms_PC_ops {
  int (*apply)(parms_PC self, parms_Vec y, parms_Vec x);
  int (*solve)(parms_PC self, parms_Vec y, parms_Vec x);
  int (*setup)(parms_PC self);
  int (*getratio)(parms_PC self, double *ratio);
} *parms_PC_ops;

extern char *pcname[];
extern char *pciluname[];

struct parms_PC_ {
  PARMS_OBJHEADER(parms_PC_ops)
  void             *data;
  parms_Mat        A;
  BOOL             istypeset;
  BOOL             isiluset;
  BOOL             issetup;
  BOOL             isopset;
  BOOL             isperm;
  int              *perm;
  int              *iperm;
  parms_FactParam  param;
  PCTYPE           pctype;
  PCILUTYPE        pcilutype;
};

#endif 
