#ifndef _PARMS_SOLVER_IMPL_H_
#define _PARMS_SOLVER_IMPL_H_

#include "parms_operator.h"
#include "parms_solver.h"
#include "parms_mat_impl.h"
#include "parms_pc_impl.h"

typedef struct parms_Solver_ops {
  int (*apply)(parms_Solver self, parms_Vec y, parms_Vec x);
  int (*setksize)(parms_Solver self, int restart);
  int (*setneig)(parms_Solver self, int neig);
} *parms_Solver_ops;

struct parms_Solver_ {
  PARMS_OBJHEADER(parms_Solver_ops)
  void         *data;
  SOLVERTYPE   stype;
  BOOL         issettype;
  BOOL         issetup;
  BOOL         isview;
  int          maxits;
  double       tol;
  int          its;
  parms_Mat    A;
  parms_PC     pc;
};

#endif 
